package packageSautJumpingSumoEleve
  model sautJumpingSumoEleve
    Modelica.Mechanics.Translational.Components.Fixed fixed1(s0 = 0) annotation(Placement(visible = true, transformation(origin = {-20, -68}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Mechanics.Translational.Components.Spring ressort(c = c, s_rel(fixed = true, start = 0.1), s_rel0 = 0.1) annotation(Placement(visible = true, transformation(origin = {28, -44}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    packageSautJumpingSumoEleve.DCMotor dCMotor1(J = 1e-07, L = 6e-05, R = 0.03, kt = 0.0005, t_m = 0) annotation(Placement(visible = true, transformation(origin = {0, 4}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Ground ground1 annotation(Placement(visible = true, transformation(origin = {-134, -58}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage1 annotation(Placement(visible = true, transformation(origin = {-134, -20}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
    Modelica.Blocks.Sources.Constant const(k = 4) annotation(Placement(visible = true, transformation(origin = {-88, -20}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
    Modelica.Mechanics.Rotational.Components.LossyGear reducteurVitesse(lossTable = [0, 0.4, 0.4, 0, 0], ratio = 5000) annotation(Placement(visible = true, transformation(origin = {40, 4}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Mechanics.Translational.Components.IdealGearR2T transformationRotationTranslation(ratio = 104.7) annotation(Placement(visible = true, transformation(origin = {84, 4}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Resistor resistor1(R = 0.05) annotation(Placement(visible = true, transformation(origin = {-106, 12}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Mechanics.Translational.Components.Mass mass1(m = 0.05) annotation(Placement(visible = true, transformation(origin = {78, -44}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation
    connect(resistor1.n, dCMotor1.pin_p) annotation(Line(points = {{-96, 12}, {-10, 12}, {-10, 8}, {-10, 8}, {-10, 10}}, color = {0, 0, 255}));
    connect(transformationRotationTranslation.flangeT, mass1.flange_b) annotation(Line(points = {{94, 4}, {110, 4}, {110, -44}, {88, -44}}, color = {0, 127, 0}));
    connect(mass1.flange_a, ressort.flange_b) annotation(Line(points = {{68, -44}, {38, -44}, {38, -44}, {38, -44}}, color = {0, 127, 0}));
    connect(reducteurVitesse.flange_b, transformationRotationTranslation.flangeR) annotation(Line(points = {{50, 4}, {74, 4}}));
    connect(resistor1.p, signalVoltage1.p) annotation(Line(points = {{-116, 12}, {-134, 12}, {-134, -10}, {-134, -10}}, color = {0, 0, 255}));
    connect(dCMotor1.flange_b, reducteurVitesse.flange_a) annotation(Line(points = {{10, 4}, {30, 4}, {30, 4}, {30, 4}}));
    connect(dCMotor1.pin_n, signalVoltage1.n) annotation(Line(points = {{-10, -1}, {-22, -1}, {-22, -36}, {-134, -36}, {-134, -30}}, color = {0, 0, 255}));
    connect(signalVoltage1.v, const.y) annotation(Line(points = {{-126, -20}, {-98, -20}, {-98, -20}, {-100, -20}}, color = {0, 0, 127}));
    connect(ground1.p, signalVoltage1.n) annotation(Line(points = {{-134, -48}, {-134, -48}, {-134, -30}, {-134, -30}}, color = {0, 0, 255}));
    connect(ressort.flange_a, fixed1.flange) annotation(Line(points = {{18, -44}, {-1, -44}, {-1, -44}, {-20, -44}, {-20, -68}, {-20, -68}}, color = {0, 127, 0}));
    annotation(Diagram(coordinateSystem(extent = {{-200, -300}, {200, 100}}, initialScale = 0.1), graphics = {Rectangle(origin = {-115, -20}, lineThickness = 1, extent = {{-51, 52}, {51, -52}}), Text(origin = {-139, 22}, lineThickness = 1, extent = {{-21, 2}, {23, -6}}, textString = "Batterie", fontName = "DejaVu Sans Mono"), Text(origin = {-17, 25}, lineThickness = 1, extent = {{-17, 3}, {31, -9}}, textString = "Moteur à courant continu", fontName = "DejaVu Sans Mono"), Text(origin = {80, -53}, lineThickness = 1, extent = {{-20, 3}, {64, -11}}, textString = "Masse déplacée pendant la contraction du ressort", fontName = "DejaVu Sans Mono")}), Icon(coordinateSystem(extent = {{-200, -300}, {200, 100}})), version = "", uses(Modelica(version = "3.2.2")), __OpenModelica_commandLineOptions = "");
  end sautJumpingSumoEleve;

  class DCMotor "DC Motor"
    //Icon
    extends Modelica.Icons.MotorIcon;
    //extends Servomechanisms.Utilities.IconName;
    //Parameters
    parameter Modelica.SIunits.Resistance R = 0.128 "Armature Resistance";
    parameter Modelica.SIunits.Inductance L = 0.000062 "Armature Inductance";
    parameter Modelica.SIunits.ElectricalTorqueConstant kt = 0.0305 "Torque Constant";
    parameter Modelica.SIunits.Inertia J = 0.000121 "Rotor Inertia";
    parameter Modelica.SIunits.RotationalDampingConstant b = 0 "Damping Factor";
    parameter Modelica.SIunits.Torque t_m = 0.001 "Max. Friction torque";
    //Components
    Modelica.Electrical.Analog.Basic.Resistor resistor(R = R) annotation(Placement(visible = true, transformation(origin = {-75, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Inductor inductor(L = L) annotation(Placement(visible = true, transformation(origin = {-25, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.EMF emf(k = kt) annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Mechanics.Rotational.Components.Inertia inertia(J = J) annotation(Placement(visible = true, transformation(origin = {75, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Mechanics.Rotational.Components.Damper damper(d = b) annotation(Placement(visible = true, transformation(origin = {60, -25}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
    Modelica.Mechanics.Rotational.Components.Fixed fixed annotation(Placement(visible = true, transformation(origin = {60, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Mechanics.Rotational.Components.BearingFriction bearingfriction(peak = 1, tau_pos = [0, t_m]) annotation(Placement(visible = true, transformation(origin = {40, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    //Sensors
    Modelica.Mechanics.Rotational.Sensors.AngleSensor anglesensor annotation(Placement(visible = true, transformation(origin = {75, 50}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
    Modelica.Mechanics.Rotational.Sensors.SpeedSensor speedsensor annotation(Placement(visible = true, transformation(origin = {75, 25}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
    //Interfaces
    Modelica.Mechanics.Rotational.Interfaces.Flange_b flange_b annotation(Placement(visible = true, transformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin pin_n annotation(Placement(visible = true, transformation(origin = {-100, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin pin_p annotation(Placement(visible = true, transformation(origin = {-100.902, 49.0984}, extent = {{-9.09836, -9.09836}, {9.09836, 9.09836}}, rotation = 0), iconTransformation(origin = {-100, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Blocks.Interfaces.RealOutput angle annotation(Placement(visible = true, transformation(origin = {50, 50}, extent = {{10, -10}, {-10, 10}}, rotation = 0), iconTransformation(origin = {-50, -100}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
    Modelica.Blocks.Interfaces.RealOutput speed annotation(Placement(visible = true, transformation(origin = {50, 25}, extent = {{10, -10}, {-10, 10}}, rotation = 0), iconTransformation(origin = {50, -100}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  equation
    connect(speedsensor.w, speed) annotation(Line(points = {{64, 25}, {56.2061, 25}, {56.2061, 24.356}, {56.2061, 24.356}}));
    connect(anglesensor.phi, angle) annotation(Line(points = {{64, 50}, {57.1429, 50}, {57.1429, 48.7119}, {57.1429, 48.7119}}));
    connect(speedsensor.flange, flange_b) annotation(Line(points = {{85, 25}, {100.234, 25}, {100.234, 0}, {100.234, 0}}));
    connect(anglesensor.flange, flange_b) annotation(Line(points = {{85, 50}, {100.234, 50}, {100.234, 0.468384}, {100.234, 0.468384}}));
    connect(fixed.flange, damper.flange_a) annotation(Line(points = {{60, -50}, {59.9532, -50}, {59.9532, -35.1288}, {59.9532, -35.1288}}));
    connect(damper.flange_b, inertia.flange_a) annotation(Line(points = {{60, -15}, {60, 0}, {64.637, 0}, {64.637, 0}}));
    connect(inertia.flange_b, flange_b) annotation(Line(points = {{85, 0}, {97.8923, 0}, {97.8923, -1.40515}, {97.8923, -1.40515}}));
    connect(bearingfriction.flange_b, inertia.flange_a) annotation(Line(points = {{50, 0}, {65.1054, 0}, {65.1054, -0.936768}, {65.1054, -0.936768}}));
    connect(emf.flange, bearingfriction.flange_a) annotation(Line(points = {{10, 0}, {30.445, 0}, {30.445, -0.468384}, {30.445, -0.468384}}));
    connect(inductor.n, emf.p) annotation(Line(points = {{-15, 50}, {0.468384, 50}, {0.468384, 9.83607}, {0.468384, 9.83607}}));
    connect(pin_n, emf.n) annotation(Line(points = {{-100, -50}, {0.936768, -50}, {0.936768, -10.7728}, {0.936768, -10.7728}}));
    connect(resistor.n, inductor.p) annotation(Line(points = {{-65, 50}, {-34.6604, 50}, {-34.6604, 50.1171}, {-34.6604, 50.1171}}));
    connect(resistor.p, pin_p) annotation(Line(points = {{-85, 50}, {-100.234, 50}, {-100.234, 48.7119}, {-100.234, 48.7119}}));
    annotation(Documentation(info = "<html>
  <head>
  <style type=\"text/css\">
  h4      { border-radius:8%;background-color: #D8D8D8 ;}
  </style>
  </head>
  
  <h4>General</h4>
  <p>
  This is the model of a permanent magnet DC motor, one of the most common electromechanical actuator 
  with caractheristics as low inductance and low friction.
  It includes dead zone.
  </p>
  
  <h4>Implementation</h4>
  <strong>DCMotor</strong> is based upon the mathematical model of a 
  permanent magnet dc motor.
  It is similar to the
  <a href=\"modelica://Servomechanisms.Electrical.IdealDCMotor\">
  IdealDCMotor
  </a> 
  class but this model is nonlinear. A dead zone is added by 
  using the static friction of 
  <a href=\"modelica://Modelica.Mechanics.Rotational.Components.BearingFriction\">
  BearingFriction
  </a>
  component.<br>
  Using elements from 
  <a href=\"modelica://Modelica\">MSL</a>  
  the model was developed to represent the mathematical equations:<br>
  <img src=\"modelica://Servomechanisms/Resources/Images/Electrical/dcmotorequation.png\" alt=\"dcmotorequation.png\" >
  
  <h4>Notes</h4>
  <ul>
  <li>
  The behavior of the voltage source is given by a <strong>real input</strong> (for example a real source block could be connected as an input, see 
  <a href=\"modelica://Modelica.Blocks.Sources\">Modelica.Blocks.Sources</a>  
  ).
  </li>
  <li>This model is linear</li>
  <li>All the parameters and variables are in SI units</li>
  <li>Has angle and speed sensors as <strong>real outputs</strong> .</li>
  </ul>
  
  
  </html>"), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Text(origin = {-38.7173, -67.4584}, lineColor = {255, 255, 255}, extent = {{-14.4893, 12.3515}, {14.4893, -12.3515}}, textString = "Phi", fontSize = 30), Text(origin = {50.6413, -66.9359}, extent = {{-14.4893, 12.3515}, {14.4893, -12.3515}}, textString = "w", fontSize = 30)}));
  end DCMotor;

  partial record IconName
    annotation(Documentation(info = "<html>
<head>
<style type=\"text/css\">
h4      { border-radius:8%;background-color: #D8D8D8 ;}
</style>
</head>

<h4>General</h4>
<p>
Icon element.
</p>
</html>"));
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Text(lineColor = {0, 0, 255}, extent = {{-150, 150}, {150, 110}}, textString = "%name")}));
  end IconName;
end packageSautJumpingSumoEleve;